unit Polar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Menus, ExtDlgs, lmdctrl, lmdextcA;

type
  TfrmMain = class(TForm)
    Image: TImage;
    btnLight: TButton;
    btnMLines: TButton;
    TrackBarX: TTrackBar;
    TrackBarY: TTrackBar;
    TrackBarZ: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TrackBarM: TTrackBar;
    Label5: TLabel;
    TrackBarQ: TTrackBar;
    btnSpace1: TButton;
    btnSpace2: TButton;
    btnColor: TButton;
    ColorDialog: TColorDialog;
    PopupMenu: TPopupMenu;
    mnuSave: TMenuItem;
    SavePictureDialog: TSavePictureDialog;
    LMDScrollText: TLMDScrollText;
    mnuAboit: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure btnLightClick(Sender: TObject);
    procedure btnMLinesClick(Sender: TObject);
    procedure btnSpace1Click(Sender: TObject);
    procedure btnSpace2Click(Sender: TObject);
    procedure TrackBarXChange(Sender: TObject);
    procedure TrackBarYChange(Sender: TObject);
    procedure TrackBarZChange(Sender: TObject);
    procedure TrackBarMChange(Sender: TObject);
    procedure TrackBarQChange(Sender: TObject);
    procedure btnColorClick(Sender: TObject);
    procedure mnuSaveClick(Sender: TObject);
    procedure mnuAboitClick(Sender: TObject);
    procedure LMDScrollTextClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
    x,y,z,mx,t,dt,q,m,v,vx,vy,vz,fx,fy,fz,al:real;
    e,ex,ey,ez,b,bx,by,bz:real;
    j,gd,gm,x8,y8:integer;
    ll:boolean;

implementation

{$R *.DFM}

procedure way(x,y,z,vx,vy,vz,tm:real;cl:TColor);
begin
   p:=1e22; mu:=1.26e-6; m:=tm*1.7e-27;
   t:=0; dt:=1e-3;
   r2:=x*x+y*y; r:=sqrt(r2); r3:=r2*r;
   bx:=mu*3*p*x/r3*y/r2; by:=mu*p/r3*(3*y*y-r*r)/r2;
   bz:=mu*3*p*x/r3*z/r2;
   fx:=q*(vy*bz-vz*by); vx:=vx+fx*dt/m; x:=x+vx*dt;
   fy:=q*(vz*bx-vx*bz); vy:=vy+fy*dt/m; y:=y+vy*dt;
   fz:=q*(vx*by-vy*bx); vz:=vz+fz*dt/m; z:=z+vz*dt;
   x8:=frmMain.Image.Width-2+round((x-z/3)*mx);
   y8:=frmMain.Image.Height-2-round((y-z/3)*mx);
   frmMain.Image.Canvas.moveTo(x8,y8);
   frmMain.Image.Canvas.pen.Color:=cl;
   repeat
     r2:=x*x+y*y; r:=sqrt(r2); r3:=r2*r;
     if r>=re then
       begin
         bx:=mu*3*p*x/r3*y/r2; by:=mu*p/r3*(3*y*y-r*r)/r2;
         bz:=mu*3*p*x/r3*z/r2;
         fx:=q*(vy*bz-vz*by); vx:=vx+fx*dt/m; x:=x+vx*dt;
         fy:=q*(vz*bx-vx*bz); vy:=vy+fy*dt/m; y:=y+vy*dt;
         fz:=q*(vx*by-vy*bx); vz:=vz+fz*dt/m; z:=z+vz*dt;
         x8:=frmMain.Image.Width-2+round((x-z/3)*mx);
         y8:=frmMain.Image.Height-2-round((y-z/3)*mx);
         t:=t+dt;
         frmMain.Image.Canvas.LineTo(x8,y8);
       end;
       ll:=(x8<0)or(x8>frmMain.Image.Width-2)or(y8<0)or(y8>frmMain.Image.Height-2)
   until (t>70)or ll or (r<re);
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Image.Width:=768;
  Image.Height:=512;
  TrackBarX.Position:=5;
  TrackBarY.Position:=5;
  TrackBarZ.Position:=5;
  TrackBarM.Position:=5;
  TrackBarQ.Position:=5;
  vx:=1e7*TrackBarX.Position;
  vy:=1e7*(TrackBarY.Position-5);
  vz:=1e7*(TrackBarZ.Position-5);
  tm:=(TrackBarM.Position+1)/6;
  q:=1.6e-19*(TrackBarQ.Position+10)/15;
  ccl:=$02ffffff;
end;

procedure TfrmMain.btnLightClick(Sender: TObject);
begin
   p:=1e22; mu:=1.26e-6; x:=-6.3e7; y:=5e6; z:=5;
   t:=0; dt:=1e-3;
   //frmMain.Image.Canvas.pen.Color:=ccl; //500000;
   re:=6.37; ra:=6.97e6; mx:=1e-5;
   p:=1; dx:=3; daL:=0.03;
   way(x,y,z,vx,vy,vz,tm,ccl);
end;

procedure TfrmMain.btnMLinesClick(Sender: TObject);
begin
  frmMain.Image.Canvas.pen.Color:=$02ccff00;
  re:=6.37; ra:=6.97e6; mx:=1e-5;
  p:=1; dx:=3; daL:=0.03;
  aL:=dal;
  repeat
     x:=dx; y:=dx*Cos(aL)/sin(aL);
      repeat
       r2:=x*x+y*y; r:=Sqrt(r2); r3:=r2*r;
       hx:=3*p*x*y/r3/r2; hy:=p*(3*y*y-r2)/r3/r2;
       hz:=3*p*x*z/r3/r2;
       dy:=dx*hy/hx; xn:=x+dx; yn:=y+dy;
       frmMain.Image.Canvas.moveTo(frmMain.Image.Width-2+round(-x),frmMain.Image.Height-2-round(y));
       frmMain.Image.Canvas.LineTo(frmMain.Image.Width-2+round(-xn),frmMain.Image.Height-2-round(yn));
       x:=xn; y:=yn;
       ll:=((x>frmMain.Image.Width-2) or (y>frmMain.Image.Height-2))
      until (y<3)or ll;
      aL:=aL+daL;
   until aL>Pi/2;
end;

procedure TfrmMain.btnSpace1Click(Sender: TObject);
begin
  frmMain.Image.Picture.LoadFromFile('Space2.bmp')
end;

procedure TfrmMain.btnSpace2Click(Sender: TObject);
begin
  frmMain.Image.Picture.LoadFromFile('Space1.bmp')
end;

procedure TfrmMain.TrackBarXChange(Sender: TObject);
begin
  vx:=1e7*TrackBarX.Position;
end;

procedure TfrmMain.TrackBarYChange(Sender: TObject);
begin
  vy:=1e7*(TrackBarY.Position-5);
end;

procedure TfrmMain.TrackBarZChange(Sender: TObject);
begin
  vz:=1e7*(TrackBarZ.Position-5);
end;

procedure TfrmMain.TrackBarMChange(Sender: TObject);
begin
  tm:=(TrackBarM.Position+1)/6;
end;

procedure TfrmMain.TrackBarQChange(Sender: TObject);
begin
  q:=1.6e-19*(TrackBarQ.Position+10)/15;
end;

procedure TfrmMain.btnColorClick(Sender: TObject);
begin
  if ColorDialog.Execute
    then
      ccl:=ColorDialog.Color
end;

procedure TfrmMain.mnuSaveClick(Sender: TObject);
begin
  if SavePictureDialog.Execute
    then
      begin
        Image.Picture.SaveToFile(SavePictureDialog.FileName+'.bmp')
      end
end;

procedure TfrmMain.mnuAboitClick(Sender: TObject);
begin
  btnMLines.Enabled:=false;
  btnLight.Enabled:=false;
  LMDScrollText.Visible:=true;
  LMDScrollText.Scroll:=true
end;

procedure TfrmMain.LMDScrollTextClick(Sender: TObject);
begin
  LMDScrollText.Scroll:=false;
  LMDScrollText.Visible:=false;
  btnMLines.Enabled:=true;
  btnLight.Enabled:=true;
end;

end.
